Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DocumentAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DocumentAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DocumentAction.java	(revision 25635)
@@ -35,4 +35,5 @@
 import java.util.HashSet;
 import java.io.File;
+import java.io.Serializable;
 
 import org.apache.log4j.*;
@@ -90,5 +91,5 @@
 		Element request = (Element) GSXML.getChildByTagName(message, GSXML.REQUEST_ELEM);
 		Element cgi_paramList = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_paramList, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_paramList, false);
 
 		// just in case there are some that need to get passed to the services
@@ -360,5 +361,5 @@
 		// Create a parameter list to specify the required metadata information
 
-		HashSet meta_names = new HashSet();
+		HashSet<String> meta_names = new HashSet<String>();
 		meta_names.add("Title"); // the default
 		if (format_elem != null)
@@ -722,5 +723,5 @@
 		// do the query again to get term info 
 		Element cgi_param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 
 		HashMap previous_params = (HashMap) params.get("p");
@@ -767,5 +768,5 @@
 		Element metadata_list = (Element) GSXML.getNodeByPath(mr_query_response, metadata_path);
 
-		HashSet query_term_variants = new HashSet();
+		HashSet<String> query_term_variants = new HashSet<String>();
 		NodeList equivalent_terms_nodelist = query_term_list_element.getElementsByTagName("equivTermList");
 		if (equivalent_terms_nodelist == null || equivalent_terms_nodelist.getLength() == 0)
@@ -809,10 +810,10 @@
 		}
 
-		ArrayList phrase_query_term_variants_hierarchy = new ArrayList();
+		ArrayList<ArrayList<HashSet<String>>> phrase_query_term_variants_hierarchy = new ArrayList<ArrayList<HashSet<String>>>();
 
 		Element query_element = GSXML.getNamedElement(metadata_list, GSXML.METADATA_ELEM, GSXML.NAME_ATT, "query");
 		String performed_query = GSXML.getNodeText(query_element) + " ";
 
-		ArrayList phrase_query_p_term_variants_list = new ArrayList();
+		ArrayList<HashSet<String>> phrase_query_p_term_variants_list = new ArrayList<HashSet<String>>();
 		int term_start = 0;
 		boolean in_term = false;
@@ -840,5 +841,5 @@
 				{
 
-					HashSet phrase_query_p_term_x_variants = new HashSet();
+					HashSet<String> phrase_query_p_term_x_variants = new HashSet<String>();
 
 					NodeList term_equivalent_terms_nodelist = term_element.getElementsByTagName("equivTermList");
@@ -879,5 +880,5 @@
 					{
 						phrase_query_term_variants_hierarchy.add(phrase_query_p_term_variants_list);
-						phrase_query_p_term_variants_list = new ArrayList();
+						phrase_query_p_term_variants_list = new ArrayList<HashSet<String>>();
 					}
 				}
@@ -898,5 +899,5 @@
 				}
 
-				phrase_query_p_term_variants_list = new ArrayList();
+				phrase_query_p_term_variants_list = new ArrayList<HashSet<String>>();
 			}
 		}
@@ -908,5 +909,5 @@
 	 * Highlights query terms in a piece of text.
 	 */
-	private Element highlightQueryTermsInternal(String content, HashSet query_term_variants, ArrayList phrase_query_term_variants_hierarchy)
+	private Element highlightQueryTermsInternal(String content, HashSet<String> query_term_variants, ArrayList<ArrayList<HashSet<String>>> phrase_query_term_variants_hierarchy)
 	{
 		// Convert the content string to an array of characters for speed
@@ -915,5 +916,5 @@
 
 		// Now skim through the content, identifying word matches
-		ArrayList word_matches = new ArrayList();
+		ArrayList<WordMatch> word_matches = new ArrayList<WordMatch>();
 		int word_start = 0;
 		boolean in_word = false;
@@ -978,12 +979,12 @@
 		}
 
-		ArrayList highlight_start_positions = new ArrayList();
-		ArrayList highlight_end_positions = new ArrayList();
+		ArrayList<Integer> highlight_start_positions = new ArrayList<Integer>();
+		ArrayList<Integer> highlight_end_positions = new ArrayList<Integer>();
 
 		// Deal with phrases now
-		ArrayList partial_phrase_matches = new ArrayList();
+		ArrayList<PartialPhraseMatch> partial_phrase_matches = new ArrayList<PartialPhraseMatch>();
 		for (int i = 0; i < word_matches.size(); i++)
 		{
-			WordMatch word_match = (WordMatch) word_matches.get(i);
+			WordMatch word_match = word_matches.get(i);
 
 			// See if any partial phrase matches are extended by this word
@@ -992,6 +993,6 @@
 				for (int j = partial_phrase_matches.size() - 1; j >= 0; j--)
 				{
-					PartialPhraseMatch partial_phrase_match = (PartialPhraseMatch) partial_phrase_matches.remove(j);
-					ArrayList phrase_query_p_term_variants_list = (ArrayList) phrase_query_term_variants_hierarchy.get(partial_phrase_match.query_phrase_number);
+					PartialPhraseMatch partial_phrase_match = partial_phrase_matches.remove(j);
+					ArrayList phrase_query_p_term_variants_list = phrase_query_term_variants_hierarchy.get(partial_phrase_match.query_phrase_number);
 					HashSet phrase_query_p_term_x_variants = (HashSet) phrase_query_p_term_variants_list.get(partial_phrase_match.num_words_matched);
 					if (phrase_query_p_term_x_variants.contains(word_match.word))
@@ -1006,9 +1007,9 @@
 							{
 								int last_highlight_index = highlight_end_positions.size() - 1;
-								int last_highlight_end = ((Integer) highlight_end_positions.get(last_highlight_index)).intValue();
+								int last_highlight_end = highlight_end_positions.get(last_highlight_index).intValue();
 								if (last_highlight_end > partial_phrase_match.start_position)
 								{
 									// There is an overlap, so remove the previous phrase match
-									int last_highlight_start = ((Integer) highlight_start_positions.remove(last_highlight_index)).intValue();
+									int last_highlight_start = highlight_start_positions.remove(last_highlight_index).intValue();
 									highlight_end_positions.remove(last_highlight_index);
 									partial_phrase_match.start_position = last_highlight_start;
@@ -1035,5 +1036,5 @@
 			for (int p = 0; p < phrase_query_term_variants_hierarchy.size(); p++)
 			{
-				ArrayList phrase_query_p_term_variants_list = (ArrayList) phrase_query_term_variants_hierarchy.get(p);
+				ArrayList phrase_query_p_term_variants_list = phrase_query_term_variants_hierarchy.get(p);
 				HashSet phrase_query_p_term_1_variants = (HashSet) phrase_query_p_term_variants_list.get(0);
 				if (phrase_query_p_term_1_variants.contains(word_match.word))
@@ -1060,6 +1061,6 @@
 		for (int i = 0; i < highlight_start_positions.size(); i++)
 		{
-			int highlight_start = ((Integer) highlight_start_positions.get(i)).intValue();
-			int highlight_end = ((Integer) highlight_end_positions.get(i)).intValue();
+			int highlight_start = highlight_start_positions.get(i).intValue();
+			int highlight_end = highlight_end_positions.get(i).intValue();
 
 			// Print anything before the highlight range
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java	(revision 25635)
@@ -25,4 +25,5 @@
 
 import java.io.PrintWriter;
+import java.io.Serializable;
 import java.io.StringWriter;
 
@@ -48,5 +49,5 @@
 	    // get the param list
     	Element cgi_param_list = (Element)GSXML.getChildByTagName(request, GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
-	    HashMap params = GSXML.extractParams(cgi_param_list, false);
+	    HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 
     	Element result = this.doc.createElement(GSXML.MESSAGE_ELEM);
@@ -75,5 +76,5 @@
         Element page_response = this.doc.createElement(GSXML.RESPONSE_ELEM);
 
-        Iterator it = params.keySet().iterator();
+        Iterator<String> it = params.keySet().iterator();
 
         if(subaction.equals("saveDocument"))
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GS2BrowseAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GS2BrowseAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GS2BrowseAction.java	(revision 25635)
@@ -13,4 +13,5 @@
 import java.util.Vector;
 import java.io.File;
+import java.io.Serializable;
 
 import org.apache.log4j.*;
@@ -47,5 +48,5 @@
 		// extract the params from the cgi-request, and check that we have a coll specified
 		Element cgi_paramList = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_paramList, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_paramList, false);
 
 		String service_name = (String) params.get(GSParams.SERVICE);
@@ -107,6 +108,6 @@
 		// the id of the classifier is the top id of the selected node
 		String top_id = OID.getTop(classifier_node);
-		HashSet doc_meta_names = new HashSet();
-		HashSet class_meta_names = new HashSet();
+		HashSet<String> doc_meta_names = new HashSet<String>();
+		HashSet<String> class_meta_names = new HashSet<String>();
 		// add in the defaults
 		doc_meta_names.add("Title");
@@ -358,5 +359,5 @@
 	}
 
-	protected void extractMetadataNames(Element new_format, HashSet doc_meta_names, HashSet class_meta_names)
+	protected void extractMetadataNames(Element new_format, HashSet<String> doc_meta_names, HashSet<String> class_meta_names)
 	{
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GeneralAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GeneralAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GeneralAction.java	(revision 25635)
@@ -10,4 +10,5 @@
 
 import java.io.File;
+import java.io.Serializable;
 import java.util.HashMap;
 
@@ -41,5 +42,5 @@
 		// get the param list
 		Element cgi_param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 
 		if (params.get("configChangeName") != null && params.get("configChangeValue") != null)
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/NoCollQueryAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/NoCollQueryAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/NoCollQueryAction.java	(revision 25635)
@@ -16,4 +16,5 @@
 import java.util.Iterator;
 import java.io.File;
+import java.io.Serializable;
 
 import org.apache.log4j.*;
@@ -62,5 +63,5 @@
 		// extract the params from the cgi-request, and check that we have a coll specified
 		Element cgi_param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 
 		String request_type = (String) params.get(GSParams.REQUEST_TYPE);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/PageAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/PageAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/PageAction.java	(revision 25635)
@@ -12,4 +12,5 @@
 import java.util.HashMap;
 import java.io.File;
+import java.io.Serializable;
 
 import org.apache.log4j.*;
@@ -130,5 +131,5 @@
 		// extract the params from the cgi-request, 
 		Element cgi_paramList = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_paramList, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_paramList, false);
 
 		String coll_name = (String) params.get(GSParams.COLLECTION);
@@ -214,5 +215,5 @@
 		// extract the params from the cgi-request, 
 		Element cgi_paramList = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_paramList, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_paramList, false);
 
 		String coll_name = (String) params.get(GSParams.COLLECTION);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/ProcessAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/ProcessAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/ProcessAction.java	(revision 25635)
@@ -13,4 +13,5 @@
 import java.util.Iterator;
 import java.io.File;
+import java.io.Serializable;
 
 public class ProcessAction extends Action
@@ -33,5 +34,5 @@
 		// get the param list
 		Element cgi_param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 		String service_name = (String) params.get(GSParams.SERVICE);
 		String cluster_name = (String) params.get(GSParams.CLUSTER);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java	(revision 25635)
@@ -16,4 +16,5 @@
 import java.util.Iterator;
 import java.io.File;
+import java.io.Serializable;
 
 import org.apache.log4j.*;
@@ -56,5 +57,5 @@
 		// extract the params from the cgi-request, and check that we have a coll specified
 		Element cgi_param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 
 		String request_type = (String) params.get(GSParams.REQUEST_TYPE);
@@ -189,5 +190,5 @@
 
 		// get the metadata elements needed from the format statement if any
-		HashSet metadata_names = new HashSet();
+		HashSet<String> metadata_names = new HashSet<String>();
 		metadata_names.add("Title");
 		// add in the format info to the stylesheet if there is any
@@ -246,5 +247,5 @@
 
 	/** this filters out some of the doc results for result paging */
-	protected Element filterDocList(HashMap params, HashMap service_params, Element orig_doc_list)
+	protected Element filterDocList(HashMap<String, Serializable> params, HashMap service_params, Element orig_doc_list)
 	{
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/SystemAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/SystemAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/SystemAction.java	(revision 25635)
@@ -24,4 +24,5 @@
 
 import java.io.PrintWriter;
+import java.io.Serializable;
 import java.io.StringWriter;
 
@@ -48,5 +49,5 @@
 		// get the param list
 		Element cgi_param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 
 		Element result = this.doc.createElement(GSXML.MESSAGE_ELEM);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/XMLDocumentAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/XMLDocumentAction.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/XMLDocumentAction.java	(revision 25635)
@@ -17,4 +17,5 @@
 import java.util.Iterator;
 import java.io.File;
+import java.io.Serializable;
 
 /** action class for retrieving parts of XML documents */
@@ -44,5 +45,5 @@
 		// extract the params from the cgi-request, and check that we have a coll specified
 		Element cgi_param_list = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		HashMap params = GSXML.extractParams(cgi_param_list, false);
+		HashMap<String, Serializable> params = GSXML.extractParams(cgi_param_list, false);
 
 		String collection = (String) params.get(GSParams.COLLECTION);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/build/GS2PerlConstructor.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/build/GS2PerlConstructor.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/build/GS2PerlConstructor.java	(revision 25635)
@@ -124,5 +124,5 @@
 	{
 		sendMessage(new ConstructionEvent(this, GSStatus.INFO, "Collection construction: new collection."));
-		Vector command = new Vector();
+		Vector<String> command = new Vector<String>();
 		command.add("gs2_mkcol.pl");
 		command.add("-site");
@@ -133,5 +133,5 @@
 		command.add(this.collection_name);
 		String[] command_str = {};
-		command_str = (String[]) command.toArray(command_str);
+		command_str = command.toArray(command_str);
 		if (runPerlCommand(command_str))
 		{
@@ -162,5 +162,5 @@
 		command.add(this.collection_name);
 		String[] command_str = {};
-		command_str = (String[]) command.toArray(command_str);
+		command_str = command.toArray(command_str);
 
 		if (runPerlCommand(command_str))
@@ -186,5 +186,5 @@
 
 		String[] command_str = {};
-		command_str = (String[]) command.toArray(command_str);
+		command_str = command.toArray(command_str);
 
 		if (runPerlCommand(command_str))
@@ -231,8 +231,8 @@
 
 	/** extracts all the args from the xml and returns them in a Vector */
-	protected Vector extractParameters(Element param_list)
-	{
-
-		Vector args = new Vector();
+	protected Vector<String> extractParameters(Element param_list)
+	{
+
+		Vector<String> args = new Vector<String>();
 		if (param_list == null)
 		{
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/collection/ServiceCluster.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/collection/ServiceCluster.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/collection/ServiceCluster.java	(revision 25635)
@@ -32,6 +32,4 @@
 
 import java.io.*;
-import java.io.File;
-import java.io.RandomAccessFile;
 import java.util.HashMap;
 import java.util.Iterator;
@@ -76,10 +74,10 @@
 	 * 
 	 */
-	protected HashMap service_map = null;
+	protected HashMap<String, ServiceRack> service_map = null;
 	/**
 	 * maps pseudo service names to real service names - needed if we have two
 	 * services with the same name for one collection
 	 */
-	protected HashMap service_name_map = null;
+	protected HashMap<String, String> service_name_map = null;
 
 	/** XML converter for String to DOM and vice versa */
@@ -113,8 +111,8 @@
 	public void cleanUp()
 	{
-		Iterator i = this.service_map.values().iterator();
+		Iterator<ServiceRack> i = this.service_map.values().iterator();
 		while (i.hasNext())
 		{
-			ServiceRack s = (ServiceRack) i.next();
+			ServiceRack s = i.next();
 			s.cleanUp();
 		}
@@ -134,6 +132,6 @@
 	public ServiceCluster()
 	{
-		this.service_map = new HashMap();
-		this.service_name_map = new HashMap();
+		this.service_map = new HashMap<String, ServiceRack>();
+		this.service_name_map = new HashMap<String, String>();
 		this.converter = new XMLConverter();
 		this.doc = this.converter.newDOM();
@@ -491,5 +489,5 @@
 				if (this.service_name_map.containsKey(service))
 				{
-					real_service = (String) this.service_name_map.get(service);
+					real_service = this.service_name_map.get(service);
 					// need to change the to att in the request - give the real service name
 					to = request.getAttribute(GSXML.TO_ATT);
@@ -501,5 +499,5 @@
 				Element single_message = mess_doc.createElement(GSXML.MESSAGE_ELEM);
 				single_message.appendChild(request);
-				Node response_message = ((ModuleInterface) this.service_map.get(service)).process(single_message);
+				Node response_message = this.service_map.get(service).process(single_message);
 				if (response_message != null)
 				{
@@ -884,5 +882,5 @@
 	}
 
-	public HashMap getServiceMap()
+	public HashMap<String, ServiceRack> getServiceMap()
 	{
 		return service_map;
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 25634)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 25635)
@@ -84,5 +84,5 @@
 
   /** map of names to Module objects */
-  protected HashMap module_map=null;
+  protected HashMap<String, ModuleInterface> module_map=null;
   
   /** container Document to create XML Nodes */
@@ -193,5 +193,5 @@
     }
     
-    this.module_map = new HashMap();
+    this.module_map = new HashMap<String, ModuleInterface>();
     
     // This stuff may be done at a reconfigure also
@@ -291,5 +291,5 @@
           if (this.module_map.containsKey(obj)) {
             copied_request.setAttribute(GSXML.TO_ATT, this_mod);
-            result = ((ModuleInterface)this.module_map.get(obj)).process(mess);
+            result = this.module_map.get(obj).process(mess);
             if (result !=null ) {
               // append the contents of the message to the mainResult - there will only be one response at this stage
@@ -326,5 +326,5 @@
 	return private_collection_list;
   }
-  public HashMap getModuleMap() {
+  public HashMap<String, ModuleInterface> getModuleMap() {
     return module_map;
   }
@@ -337,7 +337,7 @@
   protected void cleanUpModuleMapEntire() {
     if (this.module_map != null) {
-      Iterator i = this.module_map.values().iterator();
+      Iterator<ModuleInterface> i = this.module_map.values().iterator();
       while (i.hasNext()) {
-        ((ModuleInterface)i.next()).cleanUp();
+        i.next().cleanUp();
         i.remove();
       }
@@ -364,5 +364,5 @@
         if (name.equals(potential_site_name)) {// there was no site
           list.removeChild(item);
-          ModuleInterface m = (ModuleInterface)this.module_map.remove(name);
+          ModuleInterface m = this.module_map.remove(name);
           m.cleanUp(); // clean up any open files/connections etc 
           m=null;
@@ -851,5 +851,5 @@
       
       logger.info("found the module");
-      ModuleInterface m = (ModuleInterface)this.module_map.remove(name);
+      ModuleInterface m = this.module_map.remove(name);
       // also remove the xml bit from description list
       if (type.equals(GSXML.COLLECTION_ELEM)) {
